/*
	Created by E.Starobinskii [starobinskii@yahoo.com],SPbPU, TheorMech, 2015.
*/
$(document).ready(function(){
/*
		------<====== Prelusive ======>------
*/
	var leadCone;
	var drivenCone;
	var gui = new dat.GUI();
	var scene = new THREE.Scene();
	var spotlight = new THREE.SpotLight(0xffffff);
	var renderer = new THREE.WebGLRenderer({ antialias: false,alpha:true });
	var camera = new THREE.PerspectiveCamera(45, window.innerWidth / window.innerHeight, 0.1, 1000);
	var controls = new function() {
	  this.angulator = 2.7;
	  this.ratio = 2;
	  this.rememberedRatio = this.ratio;
	}
		
	camera.position.set(-45, 45, 45);
	camera.lookAt(scene.position);
	
	spotlight.position.set(-45, 45, 45);
	spotlight.castShadow = true;
	
	[leadCone, leadArbor, drivenCone, drivenArbor] = generateCones(controls.ratio);
	
	scene.add(leadCone);
	scene.add(leadArbor);
	scene.add(drivenCone);
	scene.add(drivenArbor);
	scene.add(spotlight);
	scene.add(new THREE.AmbientLight(0x333333));
	
	renderer.setClearColor(0x000000, 0);
	renderer.setSize(window.innerWidth, window.innerHeight);
	renderer.shadowMapEnabled = true;
	$('body').append('<div id="output">');
	$("#output").append(renderer.domElement);
	
	gui.add(controls, 'angulator', -10, 10).name('Скорость вращ.');
	gui.add(controls, 'ratio', 0.3, 3).name('Передат. число');
		
/*
		   ------<====== End ======>------
		------<====== Generator ======>------
*/
	function generateCones(squaredRatio){
		var PiBy2 = Math.PI / 2;
		var ratio = Math.sqrt(squaredRatio);
		var defaultConeRadius = 15;
		var radiusDividedByRatio = defaultConeRadius / ratio;
		var radiusMultipliedByRatio = defaultConeRadius * ratio;
		var coneMaterial = new THREE.MeshLambertMaterial({map: THREE.ImageUtils.loadTexture('./source/coneMaterial.jpg')});
		var arborMaterial = new THREE.MeshLambertMaterial({map: THREE.ImageUtils.loadTexture('./source/arborMaterial.jpg')});
		var leadConeGeometry = new THREE.CylinderGeometry(0, radiusMultipliedByRatio, radiusDividedByRatio, 50);
		var leadCone = new THREE.Mesh(leadConeGeometry, coneMaterial);
		var leadArborGeometry = new THREE.CylinderGeometry(5, 5, 50, 50);
		var leadArbor = new THREE.Mesh(leadArborGeometry, arborMaterial);
		var drivenConeGeometry = new THREE.CylinderGeometry(0, radiusDividedByRatio, radiusMultipliedByRatio, 50);
		var drivenCone = new THREE.Mesh(drivenConeGeometry, coneMaterial);
		var drivenArborGeometry = new THREE.CylinderGeometry(5, 5, 50, 50);
		var drivenArbor = new THREE.Mesh(drivenArborGeometry, arborMaterial);
		
		leadCone.position.z = - radiusDividedByRatio / 2;
		leadArbor.position.z = - radiusDividedByRatio - 25;
		leadCone.rotation.x = Math.PI / 2;
		leadArbor.rotation.x = Math.PI / 2;
		leadCone.castShadow = true;
		leadArbor.castShadow = true;
		drivenCone.position.x = radiusMultipliedByRatio / 2;
		drivenArbor.position.x = radiusMultipliedByRatio + 25;
		drivenCone.rotation.set(PiBy2, 0, PiBy2);
		drivenArbor.rotation.set(PiBy2, 0, PiBy2);
		drivenCone.castShadow = true;
		drivenArbor.castShadow = true;

		return [leadCone, leadArbor, drivenCone, drivenArbor];
	}
/*
		   ------<====== End ======>------
		------<====== Rendering ======>------
*/		
	(function render() {
	  var speed = controls.angulator / 100;
	  var ratio = controls.ratio;
	  
	  if(controls.rememberedRatio != ratio){
		  scene.remove(leadCone);
		  scene.remove(leadArbor);
		  scene.remove(drivenCone);
		  scene.remove(drivenArbor);
		  [leadCone, leadArbor, drivenCone, drivenArbor] = generateCones(ratio);
		  scene.add(leadCone);
		  scene.add(leadArbor);
		  scene.add(drivenCone);
		  scene.add(drivenArbor);
		  controls.rememberedRatio = ratio;
	  }
	  
	  leadCone.rotateY(-speed);
	  leadArbor.rotateY(-speed);
	  drivenCone.rotateY(speed * ratio);
	  drivenArbor.rotateY(speed * ratio);
	  
	  requestAnimationFrame(render);
	  renderer.render(scene, camera);
	})();
/*
		   ------<====== End ======>------
*/
});